<?php
//load db class
//require 'zb_system/function/lib/dbsql.php'; //little change
require 'zb_system/function/lib/dbmysql.php';
require 'zb_system/function/lib/dbmysqli.php';
require 'zb_system/function/lib/dbpdo_mysql.php';
require 'zb_system/function/lib/dbpdo_pgsql.php';
require 'zb_system/function/lib/dbpdo_sqlite.php';
require 'zb_system/function/lib/dbpgsql.php';
require 'zb_system/function/lib/dbsqlite.php';
require 'zb_system/function/lib/dbsqlite3.php';
//load sql class 
/*
sqlglobal cannot work without zbp
require 'zb_system/function/lib/sqlglobal.php';
require 'zb_system/function/lib/sqlmysql.php';
require 'zb_system/function/lib/sqlpgsql.php';
require 'zb_system/function/lib/sqlsqlite.php';
*/

//$zbp->load();
$option=require 'zb_users/c_option.php';
if (!$option['ZC_DATABASE_TYPE']) {
  die('当前数据库链接类型未知，操作停止。');
}

$dbmysql_server=$option['ZC_MYSQL_SERVER'];
$dbmysql_port=$option['ZC_MYSQL_PORT'];
$dbmysql_username=$option['ZC_MYSQL_USERNAME'];
$dbmysql_password=$option['ZC_MYSQL_PASSWORD'];
$dbmysql_name=$option['ZC_MYSQL_NAME'];
$dbmysql_pre=$option['ZC_MYSQL_PRE'];
$dbmysqlpersistent=$option['ZC_MYSQL_PERSISTENT'];
$dbengine=$option['ZC_MYSQL_ENGINE'];

$dbpgsql_server=$option['ZC_PGSQL_SERVER'];
$dbpgsql_port=$option['ZC_PGSQL_PORT'];
$dbpgsql_username=$option['ZC_PGSQL_USERNAME'];
$dbpgsql_password=$option['ZC_PGSQL_PASSWORD'];
$dbpgsql_name=$option['ZC_PGSQL_NAME'];
$dbpgsql_pre=$option['ZC_PGSQL_PRE'];
$dbpgsqlpersistent=$option['ZC_PGSQL_PERSISTENT'];


$dbsqlite_pre=$option['ZC_SQLITE_PRE'];
$dbsqlite_path=dirname(__FILE__) . DIRECTORY_SEPARATOR .'zb_users'.DIRECTORY_SEPARATOR.'data'.DIRECTORY_SEPARATOR.$option['ZC_SQLITE_NAME'];


$array_mysql_dblink=array(
                              $dbmysql_server,
                              $dbmysql_username,
                              $dbmysql_password,
                              $dbmysql_name,
                              $dbmysql_pre,
                              $dbmysql_port,
                              $dbmysqlpersistent,
                              $dbengine
                              );
$array_pgsql_dblink=array(
                              $dbpgsql_server,
                              $dbpgsql_username,
                              $dbpgsql_password,
                              $dbpgsql_name,
                              $dbpgsql_pre,
                              $dbpgsql_port,
                              $dbpgsqlpersistent
                              );
$array_sqlite_dblink=array(
                              $dbsqlite_path,
                              $dbsqlite_pre
                              );

$newdatatype=$option['ZC_DATABASE_TYPE'];
//$newdatatype='sqlite';
$newtype = 'Db' . $newdatatype;
$db= new $newtype();

switch ($newdatatype) {
        case 'sqlite':
        case 'sqlite3':
        case 'pdo_sqlite':
            #sqlite
            $db->Open($array_sqlite_dblink);
            $db_end_pre=$dbsqlite_pre;
            break;
        case 'pgsql':
        case 'pdo_pgsql':
            # pgsql
            $db->Open($array_pgsql_dblink);
            $db_end_pre=$dbpgsql_pre;
            break;
        case 'mysql':
        case 'mysqli':
        case 'pdo_mysql':
        default:
            #mysql
            $db->Open($array_mysql_dblink);
            $db_end_pre=$dbmysql_pre;
            break;
}
if(count($_REQUEST)>0){
$sql='select * from %pre%config where conf_Name ="system"';
$sql = str_replace('%pre%', $db_end_pre, $sql);
$array=$db->Query($sql);
$str=$array['0']['conf_Value'];
$str_array=unserialize($str);
//1、开启调试模式
$str_array['ZC_DEBUG_MODE']=false;
$str_array['ZC_DEBUG_MODE_STRICT']=false;
$str_array['ZC_DEBUG_MODE_WARNING']=false;
$str_array['ZC_DEBUG_LOG_ERROR']=false;
//2、恢复默认主题 default
$str_array['ZC_BLOG_THEME']='default';
//3、禁用全部插件//ZC_USING_PLUGIN_LIST
$str_array['ZC_USING_PLUGIN_LIST']='';
//4、关闭固化域名
$str_array['ZC_PERMANENT_DOMAIN_ENABLE']=false;
$str_array['ZC_PERMANENT_DOMAIN_REDIRECT']=false;
$str_array['ZC_PERMANENT_DOMAIN_WITH_ADMIN']=false;
$newstr=serialize($str_array);

$newsql="update %pre%config set conf_Value='".$newstr."' where conf_Name='system'";
$newsql = str_replace('%pre%', $db_end_pre, $newsql);
//die($newsql);
$db->Query($newsql);
}


/**
 * 数据库操作接口
 *
 * @package Z-BlogPHP
 * @subpackage Interface/DataBase 类库
 */
interface iDataBase {

    public function Open($array);

    public function Close();

    public function Query($query);

    public function Insert($query);

    public function Update($query);

    public function Delete($query);

    public function QueryMulti($s);

    public function EscapeString($s);

    public function CreateTable($table, $datainfo);

    public function DelTable($table);

    public function ExistTable($table);

}

/**
 * SQL语句生成类
 * @package Z-BlogPHP
 * @subpackage ClassLib/DataBase
 */
class DbSql {
    /**
     * @var null 数据库连接实例
     */
    private $db = null;
    /**
     * @var null|string 数据库类型名称
     */
    private $dbclass = null;
    /**
     * @param object $db
     */
    private $sql = null;

    public function __construct(&$db = null) {
        $this->db = &$db;
        $this->dbclass = get_class($this->db);
        $this->sql = 'sql' . $this->db->type;
    }
    /**
     * 替换数据表前缀
     * @param string $
     * @return string
     */
    public function ReplacePre(&$s) {
        $s = str_replace('%pre%', $this->db->dbpre, $s);
        return $s;
    }

    public function get() {
        $sql = new $this->sql($this->db);
        return $sql;
    }

    /**
     * 删除表,返回SQL语句
     * @param string $table
     * @return string
     */
    public function DelTable($table) {
        
        return $this->get()->drop("$table")->sql;
    }

    /**
     * 检查表是否存在，返回SQL语句
     * @param string $table
     * @param string $dbname
     * @return string
     */
    public function ExistTable($table, $dbname = '') {

        return $this->get()->exist($table, $dbname)->sql;
    }

    /**
     * 创建表，返回构造完整的SQL语句
     * @param string $table
     * @param array $datainfo
     * @return string
     */
    public function CreateTable($table, $datainfo, $engine = null) {

        $sql = $this->get();
        $sql->create($table)->data($datainfo);
        if (!is_null($engine)) {
            $sql->option(array('engine' => $engine));
        }

        return $sql->sql;

    }


    /**
     * 构造查询语句
     * @param string $table
     * @param string $select
     * @param string $where
     * @param string $order
     * @param string $limit
     * @param array|null $option
     * @return string 返回构造的语句
     */
    public function Select($table, $select = null, $where = null, $order = null, $limit = null, $option = null) {
        if (!is_array($option)) {
            $option = array();
        }

        $sql = $this->get()->select($table)->option($option)->where($where)->orderBy($order)->limit($limit);

        if (isset($option['select2count'])) {
            foreach ($select as $key => $value) {
                if (count($value) > 2) {
                    $sql->count(array_slice($value, 1));
                } else {
                    $sql->count($value);
                }
                
            }
        } else {
            if (!is_array($select)) {
                $select = array($select);
            }
            call_user_func_array(array($sql, 'column'), $select);
        }

        if (!empty($option)) {
            if (isset($option['pagebar'])) {
                if ($option['pagebar']->Count === null) {
                    $s2 = $this->Count($table, array(array('*', 'num')), $where);
                    $option['pagebar']->Count = GetValueInArrayByCurrent($this->db->Query($s2), 'num');
                }
                $option['pagebar']->Count = (int) $option['pagebar']->Count;
                $option['pagebar']->make();
            }
        }
        $sql = $sql->sql;

        return $sql;
    }

    /**
     * 构造计数语句
     * @param string $table
     * @param string $count
     * @param string $where
     * @param null $option
     * @return string 返回构造的语句
     */
    public function Count($table, $count, $where = null, $option = null) {
        if (!is_array($option)) {
            $option = array('select2count' => true);
        }

        return $this->Select($table, $count, $where, null, null, $option);
    }

    /**
     * 构造数据更新语句
     * @param string $table
     * @param string $keyvalue
     * @param string $where
     * @param array|null $option
     * @return string 返回构造的语句
     */
    public function Update($table, $keyvalue, $where, $option = null) {
        return $this->get()->update($table)->data($keyvalue)->where($where)->option($option)->sql;
    }

    /**
     * 构造数据插入语句
     * @param string $table
     * @param string $keyvalue
     * @return string 返回构造的语句
     */
    public function Insert($table, $keyvalue) {

        return $this->get()->insert($this->db)->insert($table)->data($keyvalue)->sql;
    }

    /**
     * 构造数据删除语句
     * @param string $table
     * @param string $where
     * @param array|null $option
     * @return string 返回构造的语句
     */
    public function Delete($table, $where, $option = null) {

        return $this->get()->delete($this->db)->delete($table)->where($where)->option($option)->sql;
    }

    /**
     * 返回经过过滤的SQL语句
     * @param $sql
     * @return mixed
     */
    public function Filter($sql) {
        //$_SERVER['_query_count'] = $_SERVER['_query_count'] + 1;

     /*   foreach ($GLOBALS['hooks']['Filter_Plugin_DbSql_Filter'] as $fpname => &$fpsignal) {
            $fpname($sql);
        }
        */
        //Logs($sql);
        return $sql;
    }

    /**
     * 导出sql生成语句，用于备份数据用。
     * @param $type 数据连接类型
     * @return mixed
     */
    private $_explort_db = null;
    public function Export($table, $keyvalue, $type = 'mysql') {

        if ($type == 'mysql' && $this->_explort_db === null) {
            $this->_explort_db = new DbMySQL;
        }

        if ($type == 'mysqli' && $this->_explort_db === null) {
            $this->_explort_db = new DbMySQLi;
        }

        if ($type == 'pdo_mysql' && $this->_explort_db === null) {
            $this->_explort_db = new Dbpdo_MySQL;
        }

        if ($type == 'sqlite' && $this->_explort_db === null) {
            $this->_explort_db = new DbSQLite;
        }

        if ($type == 'sqlite3' && $this->_explort_db === null) {
            $this->_explort_db = new DbSQLite3;
        }

        if ($type == 'pdo_sqlite' && $this->_explort_db === null) {
            $this->_explort_db = new Dbpdo_SQLite;
        }

        if ($this->_explort_db === null) {
            $this->_explort_db = new DbMySQL;
        }

        $sql = "INSERT INTO $table ";

        $sql .= '(';
        $comma = '';
        foreach ($keyvalue as $k => $v) {
            if (is_null($v)) {
                continue;
            }

            $sql .= $comma . "$k";
            $comma = ',';
        }
        $sql .= ')VALUES(';

        $comma = '';
        foreach ($keyvalue as $k => $v) {
            if (is_null($v)) {
                continue;
            }

            $v = $this->_explort_db->EscapeString($v);
            $sql .= $comma . "'$v'";
            $comma = ',';
        }
        $sql .= ')';

        return $sql . ";\r\n";
    }
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="zh-cn" lang="zh-cn">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<meta http-equiv="Content-Language" content="zh-cn" />
	<meta http-equiv="pragma" content="no-cache">
	<meta http-equiv="cache-control" content="no-cache,must-revalidate">
	<meta http-equiv="expires" content="0">
	<meta name="robots" content="none" />
	<title>Z-BlogPHP 紧急救援工具</title>
<style type="text/css">
<!--
*{
	font-size:14px;
}
body{
	margin:0;
	padding:0;
	color: #FFFFFF;
	font-size:12px;
	background:#FFFFFF;
	font-family:"微软雅黑","黑体","宋体";
}
h1,h2,h3,h4,h5,h6{
	font-size:18px;
	padding:0;
	margin:0;
}
a{
	text-decoration: none;
}
a:link {
	color:#FFFFFF;
	text-decoration: none;
}
a:visited {
	color:#FFFFFF;
	text-decoration: none;
}
a:hover {
	color:yellow;
	text-decoration: underline;
}
a:active {
	color:yellow;
	text-decoration: underline;
}
p{
	margin:0;
	padding:5px;
}
table {
	border-collapse: collapse;
	border:0px solid #333333;
	background:#ffffff;
	margin-top:10px;
}
td{
	border:0px solid #333333;
	margin:0;
	padding:3px;
}
img{
	border:0;
}
hr{
	border:0px;
	border-top:1px solid #666666;
	background:#666666;
	margin:2px 0 4px 0;
	padding:0;
	height:0px;
}
img{
	margin:0;
	padding:0;
}
form{
	margin:0;
	padding:0;
}


#frmLogin{
	position:absolute;
	left: 50%;
	top: 40%;
	margin: -150px 0px 0px -300px;
	padding:0;
	overflow:hidden;
	width:600px;
	height:400px;
	background-color:#3a6ea5;
	border:0px solid #B3C3CD;
	box-shadow: 0px 0px 15px black;
}

#frmLogin h3{
	padding:15px 0 5px 0;
	margin:0;
	text-align:center;
	color:white;
	font-size:24px;
	height:30px;
}

#divHeader{
	margin:0 0;
	padding:8px;
}
#divMain{
	height:280px;
}
#divFooter{
	margin:5px 0px 0 0px;
	text-align:center;
	padding:2px;
}

#divMain_Top{
	padding:8px;
	padding-bottom:0;
}
#divMain_Center{
	padding:5px;
}
#divMain_Bottom{
	text-align:right;
	padding:5px;
}
#txaContent{
	border:1px solid #A1B0B9;
	background:#FFFFFF;
}
-->
</style>
</head>
<body>


<form id="frmLogin" method="post">
<h3>Z-BlogPHP 紧急救援工具</h3>
<div id="divHeader">&nbsp;&nbsp;<a href="http://www.birdol.com/" target="_blank">鸟儿博客</a>&nbsp;&nbsp;&nbsp;&nbsp;|&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://www.birdol.com" class="here" target="_blank">交流QQ群：194173880</a>&nbsp;&nbsp;&nbsp;&nbsp;|&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://www.birdol.com/" target="_blank">售后QQ群：383741852</a></div>
<div id="divMain">
<input type="hidden" name="userid" id="userid" value="0" />
<?php

echo '<p></p>';

        echo '<p style="padding:10px;">[谨慎使用！！！]<input style="float:right;" type="button" value="&nbsp;&nbsp;一键拯救&nbsp;&nbsp;" onclick="window.location=\'?go=go\'" /></p>';




?>
</div>
<div id="divFooter"><b>[注意]&nbsp;<font color="yellow"> 此工具非常危险,使用后请立刻通过<u>FTP</u>删除或改名.</font></b></div>
</form>
</body>
</html>



